/**
 * <p>Diese Klasse wird die nchste, die bernchste und die vorherige
 * Position des Balls gespeichert.
 * Bei den *real* Attributen handelt es sich um den taschlich von der
 * Strategie verwendeten Werte. Er ist beim Spiel von links nach rechts
 * identisch mit dem "normalen" Attribut und wird nur beim Spiel von rechts
 * nach links am Mittelpunkt gespiegelt. </p>
 * @author Alexander Pacnik, Johannes Wechsler
 * @version 2.0
 */

public class BallInfo extends DynamicObjectInfo
{
//*Field Detail***************************************************************//

   /** Speichert die nchste X Position des Balls (interne Berechnungen).*/
   protected double nextPosX1;
   /** Speichert die nchste X Position des Balls (tatschlich verwendeter Wert).*/
   protected double realNextPosX1;

   /** Speichert die nchste Y Position des Balls (interne Berechnungen).*/
   protected double nextPosY1;
   /** Speichert die nchste Y Position des Balls (tatschlich verwendeter Wert).*/
   protected double realNextPosY1;

   /** Speichert die bernchste X Position des Balls (interne Berechnungen).*/
   protected double nextPosX2;
   /** Speichert die bernchste X Position des Balls (tatschlich verwendeter Wert).*/
   protected double realNextPosX2;

   /** Speichert die bernchste Y Position des Balls (interne Berechnungen).*/
   protected double nextPosY2;
   /** Speichert die bernchste Y Position des Balls (tatschlich verwendeter Wert).*/
   protected double realNextPosY2;

   /** Speichert die vorherige X Position des Balls (interne Berechnungen).*/
   private double previousPosX;
   /** Speichert die vorherige X Position des Balls (tatschlich verwendeter Wert).*/
   private double realPreviousPosX;

   /** Speichert die vorherige Y Position des balls (interne Berechnungen).*/
   private double previousPosY;
   /** Speichert die vorherige Y Position des balls (tatschlich verwendeter Wert).*/
   private double realPreviousPosY;

//*Constructor Detail*********************************************************//

   /** Hier werden die Attribute auf 1000/-1000 gesetzt, was bei uns als nicht
    *  definiert gilt.*/
   public BallInfo()
   {
      this.nextPosX1 = -1000;
      this.nextPosY1 = -1000;
      this.nextPosX2 = -1000;
      this.nextPosX1 = -1000;
      this.previousPosX    = -1000;
      this.previousPosY    = -1000;
   }

//*Method Detail***************************************************************//

   public void setNextPosX1(double nextPosX1)
   { this.nextPosX1 = nextPosX1; }

   public void setNextPosY1(double nextPosY1)
   { this.nextPosY1 = nextPosY1; }

   public double getNextPosX1()
   { return this.nextPosX1; }

   public double getNextPosY1()
   { return this.nextPosY1; }

   public void setNextPosX2(double nextPosX2)
   { this.nextPosX2 = nextPosX2; }

   public void setNextPosY2(double nextPosY2)
   { this.nextPosY2 = nextPosY2; }

   public double getNextPosX2()
   { return this.nextPosX2; }

   public double getNextPosY2()
   { return this.nextPosY2; }

   public double getPreviousPosX()
   { return this.previousPosX; }

   public double getPreviousPosY()
   { return this.previousPosY; }

   public void setPreviousPosX(double previousPosX)
   { this.previousPosX = previousPosX; }

   public void setPreviousPosY(double previousPosY)
   { this.previousPosY = previousPosY; }

   public void setRealNextPosX1(double realNextPosX1)
   { this.realNextPosX1 = realNextPosX1; }

   public void setRealNextPosY1(double realNextPosY1)
   { this.realNextPosY1 = realNextPosY1; }

   public double getRealNextPosX1()
   { return this.realNextPosX1; }

   public double getRealNextPosY1()
   { return this.realNextPosY1; }

   public void setRealNextPosX2(double realNextPosX2)
   { this.realNextPosX2 = realNextPosX2; }

   public void setRealNextPosY2(double realNextPosY2)
   { this.realNextPosY2 = realNextPosY2; }

   public double getRealNextPosX2()
   { return this.realNextPosX2; }

   public double getRealNextPosY2()
   { return this.realNextPosY2; }

   public double getRealPreviousPosX()
   { return this.realPreviousPosX; }

   public double getRealPreviousPosY()
   { return this.realPreviousPosY; }

   public void setRealPreviousPosX(double realPreviousPosX)
   { this.realPreviousPosX = realPreviousPosX; }

   public void setRealPreviousPosY(double realPreviousPosY)
   { this.realPreviousPosY = realPreviousPosY; }
}