/**
 * <p> In dieser Klasse wird die X- und die Y-Position eines Objektes
 * gespeichert.
 * Bei den *real* Attributen handelt es sich um den taschlich von der
 * Strategie verwendeten Werte. Er ist beim Spiel von links nach rechts
 * identisch mit dem "normalen" Attribut und wird nur beim Spiel von rechts
 * nach links am Mittelpunkt gespiegelt.</p>
 * @author Alexander Pacnik, Johannes Wechsler
 * @version 2.0
 */

public class FieldObjectInfo extends ObjectInfo
{
//*Field Detail***************************************************************//

   /** Speichert die X-Position eines Objekts (interne Berechnungen).*/
   protected double posX;
   /** Speichert die X-Position eines Objekts (tatschlich verwendeter Wert).*/
   protected double realPosX;


   /** Speichert die Y-Position eines Onjekts (interne Berechnungen) */
   protected double posY;
   /** Speichert die Y-Position eines Onjekts (tatschlich verwendeter Wert).*/
   protected double realPosY;


//*Constructor Detail*********************************************************//

   /** Der Konstrukto setzt die Attribute auf den Standardwert -1000.*/
   public FieldObjectInfo()
   {
      this.posX    = -1000;
      this.posY    = -1000;
   }

//*Method Detail**************************************************************//

   public void setPosX(double posX)
   { this.posX = posX; }

   public void setPosY(double posY)
   { this.posY = posY; }

   public double getPosX()
   { return this.posX; }

   public double getPosY()
   { return this.posY; }

   public void setRealPosX(double realPosX)
   { this.realPosX = realPosX; }

   public void setRealPosY(double realPosY)
   { this.realPosY = realPosY; }

   public double getRealPosX()
   { return this.realPosX; }

   public double getRealPosY()
   { return this.realPosY; }
}