/**
 * <p> In dieser Klasse werden die Attribute einer Flagge gespeichert. Ihre
 * eindeutige Nummer (ID), sowie ihre berechnete X- und Y-Position.</p>
 * @author Alexander Pacnik, Johannes Wechsler
 * @version 2.0
 */

public class FlagInfo extends FieldObjectInfo
{
//*Field Detail***************************************************************//

   /** Speichert die eindeutige Nummer einer Flagge (ID).*/
   private int ID;
   /** Speichert die berechnete X-Position einer Flagge.*/
   private double estPosX;
   /** Speichert die berechnete Y-Position einer Flagge.*/
   private double estPosY;

//*Constructor Detail*********************************************************//

   /** Im Konstruktor werden die Attribute fr die jeweilig Flagge beim
    *  initialisieren gesetzt.
   * @param ID Die eindeutige Nummer der jeweiligen Flagge.
   * @param posX Die absolute X-Position einer Flagge.
   * @param posY Die absolute Y-Position einer Flagge.
   * @param time Der Zeitpunkt an dem die Flagge initialisiert wird.
   */
   public FlagInfo(int ID, double posX, double posY, int time)
   {
      if ((ID>0) && (ID<56))
      {
         this.ID = ID;
         super.posX = posX;
         super.posY = posY;
         super.time = time;
      }
      else System.out.println("ERROR: Value for ID needs to be between 1 to 55");
   }

//*Method Detail**************************************************************//

   public void setID(int ID)
   { this.ID = ID; }

   public int getID()
   {   return this.ID;   }

   public void setEstPosX(double estPosX)
   {   this.estPosX = estPosX; }

   public void setEstPosY(double estPosY)
   {   this.estPosY = estPosY; }

   public double getEstPosX()
   { return this.estPosX; }

   public double getEstPosY()
   { return this.estPosY; }
}