/*******************************************************************************
*   GUI
*
*   <br><br>
*
*   Visualisierung zeigt folgendes in den Labels bisher an:
*   <br>
*   PlayMode, BallPos, BallTime, CatchBan, PlayerIsOutside, OwnPlayerPos,
*   PlayerNearOutside, HeadAngle, RealViewDirection, Stamina, Side,
*   Status Strategie, Near Ball, RunDirection, BallDirection
*
*   <br><br>
*
*   Visualisierung zeigt folgendes auf dem Spielfeld bisher an:
*   <br>
*   komplette Spielfeldmarkierung, Eigener Spieler (blauer Punkt),
*   Sichtfeld (grner Kegel), Laufrichtung (schwarzer Kegel),
*   Ball (weier Punkt), Ballkoordinaten, Spielerkoordinaten,
*   absolute Flaggen (gelb), relative Flaggen (rot),
*   relative Tore (rote Linie zwischen Torflaggen),
*   Mitspieler (blaue Kreise), Gegenspieler (rote Kreise), Spielernummer,
*   zuknftiger Ball (graue Kreise), Sichtlinien (schwarze Kreise)
*
*   <br><br>
*
*   Visualisierung hat folgende Auswahlfunktionen:
*   <br>
*   Auswahl der Spielfeldobjekte am rechten Rand,
*   Pause Knopf fr Labels,
*   Auswahl des Spielers am linken Rand
*
*   <br><br>
*
*   @version 3.0 mit Double Buffering
*
*   @author Markus Bngel
*
*   <br><br>
*   ***************************************************************************/

import java.awt.*;
import javax.swing.*;

public class GUI extends JFrame
{
   WorldModel wm;
   WorldModel wm1;
   WorldModel wm2;
   WorldModel wm3;
   WorldModel wm4;
   WorldModel wm5;
   WorldModel wm6;
   WorldModel wm7;
   WorldModel wm8;
   WorldModel wm9;
   WorldModel wm10;
   WorldModel wm11;

   int breite=850;
   int hoehe=620;

   //Double Buffering Komponenten
   Image offscreenImg;
   Graphics offscreen;

   //Panele oben
   JPanel northPanel  = new JPanel();
   JPanel northPanel1 = new JPanel();
   JPanel northPanel2 = new JPanel();
   JPanel northPanel3 = new JPanel();
   JPanel northPanel4 = new JPanel();
   JPanel northPanel5 = new JPanel();

   //Panele rechts
   JPanel eastPanel  = new JPanel();
   JPanel eastPanel1 = new JPanel();

   //Panele unten
   JPanel southPanel = new JPanel();

   //Panele links
   JPanel westPanel = new JPanel();

   //Label oben
   JLabel northLabel1 = new JLabel();
   JLabel northLabel2 = new JLabel();
   JLabel northLabel3 = new JLabel();
   JLabel northLabel4 = new JLabel();

   //Label unten
   JLabel southLabel1 = new JLabel();
   JLabel southLabel2 = new JLabel();
   JLabel southLabel3 = new JLabel();
   JLabel southLabel4 = new JLabel();
   JLabel southLabel5 = new JLabel();
   JLabel southLabel6 = new JLabel();
   JLabel southLabel7 = new JLabel();
   JLabel southLabel8 = new JLabel();
   JLabel southLabel9 = new JLabel();
   JLabel southLabel10 = new JLabel();
   JLabel southLabel11 = new JLabel();
   JLabel southLabel12 = new JLabel();
   JLabel southLabel13 = new JLabel();
   JLabel southLabel14 = new JLabel();
   JLabel southLabel15 = new JLabel();
   JLabel southLabel16 = new JLabel();
   JLabel southLabel17 = new JLabel();
   JLabel southLabel18 = new JLabel();
   JLabel southLabel19 = new JLabel();
   JLabel southLabel20 = new JLabel();
   JLabel southLabel21 = new JLabel();
   JLabel southLabel22 = new JLabel();
   JLabel southLabel23 = new JLabel();
   JLabel southLabel24 = new JLabel();
   JLabel southLabel25 = new JLabel();
   JLabel southLabel26 = new JLabel();
   JLabel southLabel27 = new JLabel();
   JLabel southLabel28 = new JLabel();
   JLabel southLabel29 = new JLabel();
   JLabel southLabel30 = new JLabel();

   //Radio Buttons rechts
   JRadioButton toreRadioB        = new JRadioButton();
   JRadioButton spielerRadioB     = new JRadioButton();
   JRadioButton ballRadioB        = new JRadioButton();
   JRadioButton flaggenRadioB     = new JRadioButton();
   JRadioButton xyRadioB          = new JRadioButton();
   JRadioButton nummerRadioB      = new JRadioButton();
   JRadioButton sichtfeldRadioB   = new JRadioButton();
   JRadioButton sichtlinienRadioB = new JRadioButton();
   JRadioButton laufRadioB        = new JRadioButton();

   //Pause Knopf links
   JToggleButton pauseToggleB = new JToggleButton();

   //RadioButton Umschaltleiste
   ButtonGroup group = new ButtonGroup();
   JRadioButton wm1Button  = new JRadioButton();
   JRadioButton wm2Button  = new JRadioButton();
   JRadioButton wm3Button  = new JRadioButton();
   JRadioButton wm4Button  = new JRadioButton();
   JRadioButton wm5Button  = new JRadioButton();
   JRadioButton wm6Button  = new JRadioButton();
   JRadioButton wm7Button  = new JRadioButton();
   JRadioButton wm8Button  = new JRadioButton();
   JRadioButton wm9Button  = new JRadioButton();
   JRadioButton wm10Button = new JRadioButton();
   JRadioButton wm11Button = new JRadioButton();


  //Konstruktor
   public GUI (WorldModel wm1, WorldModel wm2, WorldModel wm3, WorldModel wm4, WorldModel wm5, WorldModel wm6, WorldModel wm7, WorldModel wm8, WorldModel wm9, WorldModel wm10, WorldModel wm11)
   {
      this.wm1 = wm1;
      this.wm2 = wm2;
      this.wm3 = wm3;
      this.wm4 = wm4;
      this.wm5 = wm5;
      this.wm6 = wm6;
      this.wm7 = wm7;
      this.wm8 = wm8;
      this.wm9 = wm9;
      this.wm10 = wm10;
      this.wm11 = wm11;
      wm = new WorldModel();

      try {jbInit();}
      catch(Exception e){e.printStackTrace();}
   }


   //Initialisierung der Swing-Komponenten
   private void jbInit() throws Exception
   {
      this.setSize(breite,hoehe);
      this.setResizable(false);
      this.setVisible(true);
      this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

     //Border Layout des Frames
     this.getContentPane().setLayout(new BorderLayout());

     //Layout innerhalb der Border Bereiche setzen
     this.getContentPane().add(northPanel, BorderLayout.NORTH);
     northPanel.setLayout(new GridLayout(1,5));
     this.getContentPane().add(eastPanel, BorderLayout.EAST);
     eastPanel.setLayout(new GridLayout(10,1));
     this.getContentPane().add(southPanel, BorderLayout.SOUTH);
     southPanel.setLayout(new GridLayout(5,6));
     this.getContentPane().add(westPanel, BorderLayout.WEST);
     westPanel.setLayout(new GridLayout(12,1));

     //North Panel Inhalte
     northLabel1.setText("Score");
     northLabel3.setText("Time");

     northPanel1.setLayout(new FlowLayout());
     northPanel2.setLayout(new FlowLayout());
     northPanel3.setLayout(new FlowLayout());
     northPanel4.setLayout(new FlowLayout());
     northPanel5.setLayout(new FlowLayout());

     northPanel.add(northPanel1, null);
     northPanel.add(northPanel2, null);
     northPanel.add(northPanel3, null);
     northPanel.add(northPanel4, null);
     northPanel.add(northPanel5, null);

     northPanel1.add(northLabel1, null);
     northPanel2.add(northLabel2, null);
     northPanel4.add(northLabel3, null);
     northPanel5.add(northLabel4, null);

     //East Panel Inhalte
     toreRadioB.setText("relative Tore");
     spielerRadioB.setText("Spieler");
     ballRadioB.setText("Ball");
     flaggenRadioB.setText("Flaggen");
     xyRadioB.setText("Koordinaten");
     nummerRadioB.setText("Nummer");
     sichtfeldRadioB.setText("Sichtfeld");
     sichtlinienRadioB.setText("Sichtlinien");
     laufRadioB.setText("Laufrichtung");

     //toreRadioB.setSelected(true);
     spielerRadioB.setSelected(true);
     ballRadioB.setSelected(true);
     //flaggenRadioB.setSelected(true);
     //xyRadioB.setSelected(true);
     nummerRadioB.setSelected(true);
     //sichtfeldRadioB.setSelected(true);
     sichtlinienRadioB.setSelected(true);
     laufRadioB.setSelected(true);

     eastPanel.add(eastPanel1, null);
     eastPanel.add(toreRadioB, null);
     eastPanel.add(spielerRadioB, null);
     eastPanel.add(ballRadioB, null);
     eastPanel.add(flaggenRadioB, null);
     eastPanel.add(xyRadioB, null);
     eastPanel.add(nummerRadioB, null);
     eastPanel.add(sichtfeldRadioB, null);
     eastPanel.add(sichtlinienRadioB, null);
     eastPanel.add(laufRadioB, null);

     //South Panel Inhalte
     southLabel1.setText("PlayMode");
     southLabel3.setText("BallPos");
     southLabel5.setText("BallTime");
     southLabel7.setText("CatchBan");
     southLabel9.setText("PlayerIsOutside");
     southLabel11.setText("OwnPlayerRealPos");
     southLabel13.setText("OwnPlayerViewDirection");
     southLabel15.setText("OwnPlayerPos");
     southLabel17.setText("RealViewDirection");
     southLabel19.setText("Stamina");
     southLabel21.setText("Side");
     southLabel23.setText("Status Strategie");
     southLabel25.setText("Near Ball");
     southLabel27.setText("RunDirection");
     southLabel29.setText("BallDirection");

     southPanel.add(southLabel1, null);
     southPanel.add(southLabel2, null);
     southPanel.add(southLabel3, null);
     southPanel.add(southLabel4, null);
     southPanel.add(southLabel5, null);
     southPanel.add(southLabel6, null);
     southPanel.add(southLabel7, null);
     southPanel.add(southLabel8, null);
     southPanel.add(southLabel9, null);
     southPanel.add(southLabel10, null);
     southPanel.add(southLabel11, null);
     southPanel.add(southLabel12, null);
     southPanel.add(southLabel13, null);
     southPanel.add(southLabel14, null);
     southPanel.add(southLabel15, null);
     southPanel.add(southLabel16, null);
     southPanel.add(southLabel17, null);
     southPanel.add(southLabel18, null);
     southPanel.add(southLabel19, null);
     southPanel.add(southLabel20, null);
     southPanel.add(southLabel21, null);
     southPanel.add(southLabel22, null);
     southPanel.add(southLabel23, null);
     southPanel.add(southLabel24, null);
     southPanel.add(southLabel25, null);
     southPanel.add(southLabel26, null);
     southPanel.add(southLabel27, null);
     southPanel.add(southLabel28, null);
     southPanel.add(southLabel29, null);
     southPanel.add(southLabel30, null);

      //West Panel Inhalte
      pauseToggleB.setText("Pause");
      westPanel.add(pauseToggleB, null);

      wm1Button.setText(" 1");
      wm2Button.setText(" 2");
      wm3Button.setText(" 3");
      wm4Button.setText(" 4");
      wm5Button.setText(" 5");
      wm6Button.setText(" 6");
      wm7Button.setText(" 7");
      wm8Button.setText(" 8");
      wm9Button.setText(" 9");
      wm10Button.setText("10");
      wm11Button.setText("11");
      wm1Button.setSelected(true);
      group.add(wm1Button);
      group.add(wm2Button);
      group.add(wm3Button);
      group.add(wm4Button);
      group.add(wm5Button);
      group.add(wm6Button);
      group.add(wm7Button);
      group.add(wm8Button);
      group.add(wm9Button);
      group.add(wm10Button);
      group.add(wm11Button);
      westPanel.add(wm1Button, null);
      westPanel.add(wm2Button, null);
      westPanel.add(wm3Button, null);
      westPanel.add(wm4Button, null);
      westPanel.add(wm5Button, null);
      westPanel.add(wm6Button, null);
      westPanel.add(wm7Button, null);
      westPanel.add(wm8Button, null);
      westPanel.add(wm9Button, null);
      westPanel.add(wm10Button, null);
      westPanel.add(wm11Button, null);

      this.setVisible(true);

      offscreenImg = createImage(breite,hoehe);
      offscreen = offscreenImg.getGraphics();
   }

   //Daten in den Labels updaten
   public void dataUpdate()
   {
      //Abfrage des Weltmodells fr Spieler 1 bis 11
      if ( wm1Button.isSelected() )
      { wm = wm1; }
      if ( wm2Button.isSelected() )
      { wm = wm2; }
      if ( wm3Button.isSelected() )
      { wm = wm3; }
      if ( wm4Button.isSelected() )
      { wm = wm4; }
      if ( wm5Button.isSelected() )
      { wm = wm5; }
      if ( wm6Button.isSelected() )
      { wm = wm6; }
      if ( wm7Button.isSelected() )
      { wm = wm7; }
      if ( wm8Button.isSelected() )
      { wm = wm8; }
      if ( wm9Button.isSelected() )
      { wm = wm9; }
      if ( wm10Button.isSelected() )
      { wm = wm10; }
      if ( wm11Button.isSelected() )
      { wm = wm11; }

      this.setTitle( "Visualisierung Robocup Soccer --- Player "+ wm.getNumber() );

      //NorthPanel Daten
      //Score
      northLabel2.setText(wm.getOurScore() + " : " + wm.getTheirScore());
      //Time
      northLabel4.setText("" + wm.getCurrentTime());

      //South Panel Daten
      //PlayMode
      if (wm.getPlayMode()==0) southLabel2.setText("beforeKickOff");
      if (wm.getPlayMode()==1) southLabel2.setText("kickOffLeft");
      if (wm.getPlayMode()==2) southLabel2.setText("kickOffRight");
      if (wm.getPlayMode()==3) southLabel2.setText("playOn");
      if (wm.getPlayMode()==4) southLabel2.setText("timeOver");
      if (wm.getPlayMode()==5) southLabel2.setText("kickInLeft");
      if (wm.getPlayMode()==6) southLabel2.setText("kickInRight");
      if (wm.getPlayMode()==7) southLabel2.setText("freeKickLeft");
      if (wm.getPlayMode()==8) southLabel2.setText("freeKickRight");
      if (wm.getPlayMode()==9) southLabel2.setText("goalKickLeft");
      if (wm.getPlayMode()==10) southLabel2.setText("goalKickRight");
      if (wm.getPlayMode()==11) southLabel2.setText("cornerKickLeft");
      if (wm.getPlayMode()==12) southLabel2.setText("cornerKickRight");
      if (wm.getPlayMode()==13) southLabel2.setText("goalLeft");
      if (wm.getPlayMode()==14) southLabel2.setText("goalRight");
      if (wm.getPlayMode()==15) southLabel2.setText("halfTime");

      //sonstige
      southLabel4.setText("X: "+Math.round(wm.getRealBallPosX())+" / Y:" +Math.round(wm.getRealBallPosY()));
      southLabel6.setText(""+wm.getBallTime());
      southLabel8.setText(""+wm.getCatchBan());
      southLabel10.setText(""+wm.isOwnPlayerOutside());
      southLabel12.setText("X: "+Math.round(wm.getRealOwnPlayerPosX())+ " / Y: "+Math.round(wm.getRealOwnPlayerPosY()));
      southLabel14.setText(""+wm.getOwnPlayerViewDirection());
      southLabel16.setText("X: "+Math.round(wm.getOwnPlayerPosX())+ " / Y: "+Math.round(wm.getOwnPlayerPosY()));
      southLabel18.setText(""+wm.getRealViewDirection());
      southLabel20.setText(""+wm.getStamina());

      //Side
      if (wm.getSide()==1) southLabel22.setText("left");
      if (wm.getSide()==2) southLabel22.setText("right");

      //Strategie Status
      southLabel24.setText(wm.getStrategyStatus());

      //Near Ball
      if (wm.getNearBall() == true) southLabel26.setText("true");
      else southLabel26.setText("false");

      //sonstige
      southLabel28.setText(""+wm.getOwnPlayerRunDirection());
      southLabel30.setText(""+wm.getBallDirection());
   }

   //Grafikobjekte des Fussballfeldes zeichnen
   public void paint(Graphics screen)
   {
    if(offscreen==null)return;

      if (pauseToggleB.isSelected() == false )
      { dataUpdate(); }

      offscreen.setColor(Color.black);
      offscreen.drawString("Alexander Pacnik, Johannes Wechsler, Bjrn Konrad, Christoph Zwiener, Holger Stephan, Markus Bngel",130,75);

      //Rasen
      offscreen.setColor(new Color(0, 180, 0));
      offscreen.fillRect(80,91,640,418);

      //Spielersichtfeld
      if (sichtfeldRadioB.isSelected())
      {
         int side = wm.getSide();
         int winkel=(int)wm.getRealViewDirection()*(-1);
         //if (side==2) winkel=winkel+180;
         //team too far length
         offscreen.setColor(new Color(0,200,0));
         offscreen.fillArc(((int)(wm.getRealOwnPlayerPosX()*6))-360+400,((int)(wm.getRealOwnPlayerPosY()*6))-360+300,720,720,winkel-45,90);
         //unum too far length, team far length
         offscreen.setColor(new Color(0,220,0));
         offscreen.fillArc(((int)(wm.getRealOwnPlayerPosX()*6))-240+400,((int)(wm.getRealOwnPlayerPosY()*6))-240+300,480,480,winkel-45,90);
         //unum far length
         offscreen.setColor(new Color(0,240,0));
         offscreen.fillArc(((int)(wm.getRealOwnPlayerPosX()*6))-120+400,((int)(wm.getRealOwnPlayerPosY()*6))-120+300,240,240,winkel-45,90);
      }

      //Spielersichtlinien
      if (sichtlinienRadioB.isSelected())
      {
         int side = wm.getSide();
         int winkel=(int)wm.getRealViewDirection()*(-1);
         //if (side==2) winkel=winkel+180;
         //team too far length
         offscreen.setColor(Color.black);
         offscreen.drawArc(((int)(wm.getRealOwnPlayerPosX()*6))-360+400,((int)(wm.getRealOwnPlayerPosY()*6))-360+300,720,720,winkel-45,90);
         //unum too far length, team far length
         offscreen.drawArc(((int)(wm.getRealOwnPlayerPosX()*6))-240+400,((int)(wm.getRealOwnPlayerPosY()*6))-240+300,480,480,winkel-45,90);
         //unum far length
         offscreen.drawArc(((int)(wm.getRealOwnPlayerPosX()*6))-120+400,((int)(wm.getRealOwnPlayerPosY()*6))-120+300,240,240,winkel-45,90);
      }

      //Laufrichtung
      if (laufRadioB.isSelected())
      {
         int side = wm.getSide();
         int richtung=(int)wm.getOwnPlayerRunDirection()*(-1);
         //if (side==2) richtung=richtung+180;
         offscreen.setColor(new Color(50,0,0));
         offscreen.fillArc(((int)(wm.getRealOwnPlayerPosX()*6))-90+400,((int)(wm.getRealOwnPlayerPosY()*6))-90+300,180,180,richtung-1,2);
      }

      //Spielfeldlinien
      //Aus
      offscreen.setColor(Color.white);
      offscreen.drawRect(85,96,630,408);
      //Mitte
      offscreen.drawLine(400,96,400,504);
      //Strafraum
      offscreen.drawRect(85,180,99,240);
      offscreen.drawRect(616,180,99,240);
      //Fuenferraum
      offscreen.drawRect(85,246,33,108);
      offscreen.drawRect(682,246,33,108);
      //Tore
      offscreen.setColor(Color.black);
      offscreen.drawLine(85,258,85,342);
      offscreen.drawLine(715,258,715,342);
      //Mittelkreis
      offscreen.setColor(Color.white);
      offscreen.drawOval(345,245,110,110);

      //relative Tore
      if (toreRadioB.isSelected())
      {
         offscreen.setColor(Color.red);
         offscreen.drawLine(((int)(wm.getFlagEstPosX(46)*6))+400,((int)(wm.getFlagEstPosY(46)*6))+300,((int)(wm.getFlagEstPosX(48)*6))+400,((int)(wm.getFlagEstPosY(48)*6))+300);
         offscreen.drawLine(((int)(wm.getFlagEstPosX(40)*6))+400,((int)(wm.getFlagEstPosY(40)*6))+300,((int)(wm.getFlagEstPosX(42)*6))+400,((int)(wm.getFlagEstPosY(42)*6))+300);
      }

      //absolute Flaggen
      if (flaggenRadioB.isSelected())
         {
          offscreen.setColor(Color.yellow);
          for (int ID=37; ID<=55; ID++)
             {offscreen.fillOval(((int)(wm.getFlagPosX(ID)*6))-3+400,((int)(wm.getFlagPosY(ID)*6))-3+300,6,6);}
          }

      //relative Flaggen
      if (flaggenRadioB.isSelected())
      {
       wm.setGuiPaintsFlags(true);
       offscreen.setColor(Color.red);
       for (int ID=37; ID<=55; ID++)
          {offscreen.drawOval(((int)(wm.getFlagEstPosX(ID)*6))-4+400,((int)(wm.getFlagEstPosY(ID)*6))-4+300,8,8);}
      }
      else wm.setGuiPaintsFlags(false);

      //Spieler
      offscreen.setColor(Color.blue);
      offscreen.fillOval(((int)(wm.getRealOwnPlayerPosX()*6))-8+400,((int)(wm.getRealOwnPlayerPosY()*6))-8+300,16,16);

      //Spielerkoordinaten
      offscreen.setColor(Color.blue);
      if (xyRadioB.isSelected())
      { offscreen.drawString( (int)wm.getOwnPlayerPosX()+" / "+(int)wm.getOwnPlayerPosY(),((int)(wm.getOwnPlayerPosX()*6))+5+400,((int)(wm.getBallPosY()*6))+5+300 );}

      //Blle
      if (ballRadioB.isSelected())
         {
          //zuknftige Blle
          offscreen.setColor(new Color(180,180,180));
          offscreen.fillOval(((int)(wm.getRealBallNextPosX1()*6))-5+400,((int)(wm.getRealBallNextPosY1()*6))-5+300,10,10);
          offscreen.setColor(new Color(120,120,120));
          offscreen.fillOval(((int)(wm.getRealBallNextPosX2()*6))-5+400,((int)(wm.getRealBallNextPosY2()*6))-5+300,10,10);
          //aktueller Ball
          offscreen.setColor(Color.white);
          offscreen.fillOval(((int)(wm.getRealBallPosX()*6))-5+400,((int)(wm.getRealBallPosY()*6))-5+300,10,10);
          //Ballkoordinaten
          offscreen.setColor(Color.white);
          if (xyRadioB.isSelected())
             {offscreen.drawString( (int)wm.getRealBallPosX()+" / "+(int)wm.getRealBallPosY(),((int)(wm.getRealBallPosX()*6))-5+400,((int)(wm.getRealBallPosY()*6))-5+300 );}
         }

      //Mit- und Gegenspieler
      if (spielerRadioB.isSelected())
      {
       for (int j=0; j< wm.playerList.size(); j++)
        {
         if ( ((PlayerInfo)(wm.playerList.get(j))).getTeam() == 1 ) offscreen.setColor(Color.blue);
         if ( ((PlayerInfo)(wm.playerList.get(j))).getTeam() == 2 ) offscreen.setColor(Color.red);
         if ( ((PlayerInfo)(wm.playerList.get(j))).getTeam() == (-1000) ) offscreen.setColor(Color.black);
         if ( ((PlayerInfo)(wm.playerList.get(j))).getTeam() == 0 ) offscreen.setColor(Color.black);
         offscreen.fillOval(((int)(((PlayerInfo)(wm.playerList.get(j))).getRealPosX()*6))+400,((int)(((PlayerInfo)(wm.playerList.get(j))).getRealPosY()*6))-12+300,16,16);
         offscreen.setColor(Color.white);
         if (nummerRadioB.isSelected())
         { if (((PlayerInfo)(wm.playerList.get(j))).getID() != (-1000) ) offscreen.drawString("  "+((PlayerInfo)(wm.playerList.get(j))).getID(),((int)(((PlayerInfo)(wm.playerList.get(j))).getRealPosX()*6))+400,((int)(((PlayerInfo)(wm.playerList.get(j))).getRealPosY()*6))+300 ); }
        }
      }

      //Kommentar
      if (pauseToggleB.isSelected() == true )
      {
       offscreen.setColor(Color.black);
       offscreen.drawString("!!! TEAM 5 IS GONNA WIN !!!",320,220);
       offscreen.drawString("!!! TEAM 5 IS GONNA WIN !!!",320,240);
       offscreen.drawString("!!! TEAM 5 IS GONNA WIN !!!",320,260);
       offscreen.drawString("!!! TEAM 5 IS GONNA WIN !!!",320,280);
       offscreen.drawString("!!! TEAM 5 IS GONNA WIN !!!",320,300);
       offscreen.drawString("!!! TEAM 5 IS GONNA WIN !!!",320,320);
       offscreen.drawString("!!! TEAM 5 IS GONNA WIN !!!",320,340);
       offscreen.drawString("!!! TEAM 5 IS GONNA WIN !!!",320,360);
       offscreen.drawString("!!! TEAM 5 IS GONNA WIN !!!",320,380);
       offscreen.drawString("!!! GUI is written by MARKUS BNGEL !!!",280,420);
       offscreen.drawString("!!! GUI is written by MARKUS BNGEL !!!",280,440);
       offscreen.drawString("!!! GUI is written by MARKUS BNGEL !!!",280,460);
      }

      //Image mit Double-Buffering zeichnen
      screen.drawImage(offscreenImg,0,0,this);

      //Swing Objekte mittels Paint in der Superklasse zeichnen
      super.paint(offscreen);

   }//////Ende Paint

}//Ende class
