/**
 * <p>In dieser Klasse werden allgemeine Spielinformationen gespeichert.</p>
 * @author Alexander Pacnik, Johannes Wechsler
 * @version 2.0
 */

public class GameInfo
{
//*Field Detail***************************************************************//

   /** Speichert unseren Score.*/
   private int ourScore;
   /** Speichert den Score des Gegeners.*/
   private int theirScore;
   /** Speichert die aktuelle Spielzeit.*/
   private int currentTime;
   /** Speichert den aktuellen playMode.*/
   private int playMode;
   /** Speichert auf welcher Seite des Spielfeld wir spielen.*/
   private int side;
   /** Ist der Button der GUI aktiv, der die Flaggen anzeigt.*/
   private boolean guiPaintsFlags;
   /** Status der Strategie.*/
   private String strategyStatus;
   /** Ist der Spieler in der nhe des Balls?*/
   private boolean nearBall;
   /** Name des teams.*/
   String teamName;

//*Constructor Detail*********************************************************//

   /** Der Konstruktur setzt wieder die default values.*/
   public GameInfo()
   {
      ourScore       = 0;
      theirScore     = 0;
      currentTime    = -1000;
      playMode       = -1000;
      side           = -1000;
      guiPaintsFlags = false;
      strategyStatus = "";
      nearBall       = false;
      teamName       = "";
   }

//*Method Detail***************************************************************//

   public void setOurScore(int ourScore)
   { this.ourScore = ourScore; }

   public void setPlayMode(int playMode)
   { this.playMode = playMode; }

   public void setTheirScore(int theirScore)
   { this.theirScore = theirScore; }

   public void setCurrentTime(int currentTime)
   {
     if (currentTime >= this.currentTime)
     { this.currentTime = currentTime; }
   }

   public void setSide(int side)
   { this.side = side; }

   public int getOurScore()
   { return this.ourScore; }

   public int getPlayMode()
   { return this.playMode; }

   public int getTheirScore()
   { return this.theirScore; }

   public int getCurrentTime()
   { return this.currentTime; }

   public int getSide()
   { return this.side; }

   public void setGuiPaintsFlags(boolean guiPaintsFlags)
   { this.guiPaintsFlags = guiPaintsFlags; }

   public boolean getGuiPaintsFlags()
   { return this.guiPaintsFlags; }

   public void setStrategyStatus(String strategyStatus)
   { this.strategyStatus = strategyStatus; }

   public String getStrategyStatus()
   { return this.strategyStatus; }

   public void setNearBall(boolean nearBall)
   { this.nearBall = nearBall; }

   public boolean getNearBall()
   { return this.nearBall; }

   public void setTeamName(String teamName)
   { this.teamName = teamName; }

   public String getTeamName()
   { return this.teamName; }
}