/**
 * <p>Hier werden Attribute gespeichert, die nur den eigenen Spieler des
 * jeweiligen Weltmodells betreffen.</p>
 * @author Alexander Pacnik, Johannes Wechsler
 * @version 2.0
 */

public class OwnPlayerInfo extends PlayerInfo
{
//*Field Detail***************************************************************//

   /** Speichert die viewModeQuality eines Spielers; high=1, low=2.*/
   private int    viewModeQuality;
   /** Speichert die viewModeRange eines Spielers; narrow=1, normal=2 oder wide=3.*/
   private int    viewModeRange;
   /** Speichert die Stamina eines Spielers.*/
   private double stamina;
   /** Speichert den effort eines Spielers*/
   private double effort;
   /** Speichert den amountOfSpeed eines Speilers.*/
   private double amountOfSpeed;
   /** Speichert den directionOfSpeed eines Spielers.*/
   private double directionOfSpeed;
   /** Speichert den headAngle eines Spielers.*/
   private double headAngle;
   /** Speichert den kickCount.*/
   private int    kickCount;
   /** Speichert den dashCount */
   private int    dashCount;
   /** Speichert den turnCount.*/
   private int    turnCount;
   /** Speichert den sayCount.*/
   private int    sayCount;
   /** Speichert den turnNeckCount.*/
   private int    turnNeckCount;
   /** Speicher den catchCount.*/
   private int    catchCount;
   /** Speichert den moveCount.*/
   private int    moveCount;
   /** Speichert den changeViemCount.*/
   private int    changeViewCount;
   /** Speichert die viewDirection.*/
   private double viewDirection;
   /** Speichert die runDirection.*/
   private double runDirection;
   /** Speichert die catchBanTime.*/
   private int    catchBanTime;
   /** Speichert die realViewDirectio.*/
   private double realViewDirection;
   /** Speichert die isPlayerOutside.*/
   private boolean isPlayerOutside;
   /** Speichert die isPlayerNearOutside.*/
   private boolean isPlayerNearOutside;

//*Constructor Detail*********************************************************//

   /** Setzt die Attribute auf die default Werte..*/
   public OwnPlayerInfo()
   {
      viewModeQuality  = -1000;
      viewModeRange    = -1000;
      stamina          = -1000;
      effort           = -1000;
      amountOfSpeed    = -1000;
      directionOfSpeed = -1000;
      headAngle        = -1000;
      kickCount        = -1000;
      dashCount        = -1000;
      turnCount        = -1000;
      sayCount         = -1000;
      turnNeckCount    = -1000;
      catchCount       = -1000;
      moveCount        = -1000;
      changeViewCount  = -1000;
      viewDirection    = -1000;
      runDirection     = -1000;
      catchBanTime     = -1000;
      realViewDirection = -1000;
      isPlayerOutside = false;
      isPlayerNearOutside = false;
   }

//*Method Detail**************************************************************//

   public double getOwnPlayerViewDirection()
   { return this.viewDirection; }

   public void setOwnPlayerViewDirection(double viewDirection)
   { this.viewDirection = viewDirection; }

   public void setRealViewDirection(double realViewDirection)
   { this.realViewDirection = realViewDirection; }

   public double getRealViewDirection()
   { return this.realViewDirection; }

   public void setViewModeQuality(int viewModeQuality)
   {  this.viewModeQuality = viewModeQuality; }

   public int getViewModeQuality()
   { return this.viewModeQuality; }

   public void setViewModeRange(int viewModeRange)
   {  this.viewModeRange = viewModeRange; }

   public int getViewModeRange()
   { return this.viewModeRange; }

   public void setStamina(double stamina)
   {  this.stamina = stamina; }

   public double getStamina()
   { return this.stamina; }

   public void setEffort(double effort)
   {  this.effort = effort; }

   public double getEffort()
   { return this.effort; }

   public void setAmountOfSpeed(double amountOfSpeed)
   {  this.amountOfSpeed = amountOfSpeed; }

   public double getAmountOfSpeed()
   { return this.amountOfSpeed; }

   public void setDirectionOfSpeed(double directionOfSpeed)
   {  this.directionOfSpeed = directionOfSpeed; }

   public double getDirectionOfSpeed()
   { return this.directionOfSpeed; }

   public void setHeadAngle(double headAngle)
   {  this.headAngle = headAngle; }

   public double getHeadAngle()
   { return this.headAngle; }

   public void setKickCount(int kickCountNew)
   { this.kickCount = kickCount; }

   public int getKickCount()
   { return this.kickCount; }

   public void setDashCount(int dashCount)
   { this.dashCount = dashCount; }

   public int getDashCount()
   { return this.dashCount; }

   public void setTurnCount(int turnCount)
   { this.turnCount = turnCount; }

   public int getTurnCount()
   { return this.turnCount; }

   public void setSayCount(int sayCount)
   { this.sayCount = sayCount; }

   public int getSayCount()
   { return this.sayCount; }

   public void setTurnNeckCount(int turnNeckCount)
   { this.turnNeckCount = turnNeckCount; }

   public int getTurnNeckCount()
   { return this.turnNeckCount; }

   public void setCatchCount(int catchCount)
   { this.catchCount = catchCount; }

   public int getCatchCount()
   { return this.catchCount; }

   public void setMoveCount(int moveCount)
   { this.moveCount = moveCount; }

   public int getMoveCount()
   { return this.moveCount; }

   public void setChangeViewCount(int changeViewCount)
   { this.changeViewCount = changeViewCount; }

   public int getChangeViewCount()
   { return this.changeViewCount; }

   public void setRunDirection(double runDirection)
   { this.runDirection = runDirection; }

   public double getRunDirection()
   { return this.runDirection; }

   public void setCatchBanTime( int catchBanTime)
   { this.catchBanTime = catchBanTime; }

   public int getCatchBanTime()
   { return this.catchBanTime; }

   public void setOutside(boolean isPlayerOutside)
   { this.isPlayerOutside = isPlayerOutside; }

   public boolean isOutside()
   { return this.isPlayerOutside; }

   public void setNearOutside(boolean isPlayerNearOutside)
   { this.isPlayerNearOutside = isPlayerNearOutside; }

   public boolean isNearOutside()
   { return this.isPlayerNearOutside; }
}
