/**
 * <p>Die Klasse beinhaltet elf Spieler sowie eine GUI zur Visualisierung der
 * Weltmodelle der elf Spieler. Das Programm wird mit dieser Klasse gestartet,
 * in der die elf Spieler initialisiert werden.</p>
 * @author Johannes Wechsler
 * @version 2.0
 */

public class RoboClient extends Thread
{
   /** Spieler 1 */
   private Player player1;
   /** Spieler 2 */
   private Player player2;
   /** Spieler 3 */
   private Player player3;
   /** Spieler 4 */
   private Player player4;
   /** Spieler 5 */
   private Player player5;
   /** Spieler 6 */
   private Player player6;
   /** Spieler 7 */
   private Player player7;
   /** Spieler 8 */
   private Player player8;
   /** Spieler 9 */
   private Player player9;
   /** Spieler 10 */
   private Player player10;
   /** Spieler 11 */
   private Player player11;
   /** GUI zur Visualisierung der Weltmodelle der elf Spieler*/
   private static GUI gui;

  /**
   * Legt eine <code>RoboClient</code> Instanz an. In der Methode werden elf
   * Spieler initialisiert und fuer jeden die start() Methode der Player Klasse
   * aufgerufen.
   *
   * @param serverName dieser Wert gibt den Servernamen an
   * @param serverPort dieser Wert gibt den Port an, auf dem der Server
   * nach ankommenden Paketen lauscht
   * @param teamName dieser Wert ist der Name unseres Teams
   */
   public RoboClient(String serverName, int serverPort, String teamName)
   {
      player1 = new Player(serverName, serverPort, teamName, true);
      player1.start();
      try   { sleep(100); }
      catch (InterruptedException e) {}

      player2 = new Player(serverName, serverPort, teamName, false);
      player2.start();
      try   { sleep(100); }
      catch (InterruptedException e) {}

      player3 = new Player(serverName, serverPort, teamName, false);
      player3.start();
      try   { sleep(100); }
      catch (InterruptedException e) {}

      player4 = new Player(serverName, serverPort, teamName, false);
      player4.start();
      try   { sleep(100); }
      catch (InterruptedException e) {}

      player5 = new Player(serverName, serverPort, teamName, false);
      player5.start();
      try   { sleep(100); }
      catch (InterruptedException e) {}

      player6 = new Player(serverName, serverPort, teamName, false);
      player6.start();
      try   { sleep(100); }
      catch (InterruptedException e) {}

      player7 = new Player(serverName, serverPort, teamName, false);
      player7.start();
      try   { sleep(100); }
      catch (InterruptedException e) {}

      player8 = new Player(serverName, serverPort, teamName, false);
      player8.start();
      try   { sleep(100); }
      catch (InterruptedException e) {}

      player9 = new Player(serverName, serverPort, teamName, false);
      player9.start();
      try   { sleep(100); }
      catch (InterruptedException e) {}

      player10 = new Player(serverName, serverPort, teamName, false);
      player10.start();
      try   { sleep(100); }
      catch (InterruptedException e) {}

      player11 = new Player(serverName, serverPort, teamName, false);
      player11.start();
      try   { sleep(100); }
      catch (InterruptedException e) {}
   }

   /**
    * Aktualisieren der GUI durch Aufruf von repaint().
    */
   public static void guiUpdate()
   {
      if(gui != null)
      { gui.repaint(); }
   }
   /**
    * Startet den Client
    *
    * @param args Die Argumente muessen <code>SERVERNAME PORT TEAMNAME [GUI]</code>
    * in dieser Reihenfolge sein
    */
   public static void main (String [] args)
   {
      //Wenn weniger als drei Argumente uebergeben wurden, dann beende das Programm
      if (args.length < 3)
      {
         System.out.println("Usage :  java RoboClient servername serverport teamname [gui]");
         System.exit(1);
      }
      //Anlegen einer RoboClient Instanz
      else
      {
         RoboClient rc = new RoboClient(args[2], Integer.parseInt(args[1]), args[0]);
         //Anlegen der GUI, wenn das Argument GUI uebergeben wurde
         if ((args.length == 4) && (args[3]!=null) && (args[3].equals("gui")))
         { gui = new GUI(rc.player1.getWorldModel(), rc.player2.getWorldModel(), rc.player3.getWorldModel(), rc.player4.getWorldModel(), rc.player5.getWorldModel(), rc.player6.getWorldModel(), rc.player7.getWorldModel(), rc.player8.getWorldModel(), rc.player9.getWorldModel(), rc.player10.getWorldModel(), rc.player11.getWorldModel()); }
      }
   }
}