
/*******************************************************************************
* <p>Title: Strategie</p>
* <p>Description: Diese Klasse entscheidet aufgrund der Daten des Weltmodells
* ber die auszufhrende Aktion</p>
* <p>Copyright: Copyright (c) 2002</p>
* @author Bjrn Konrad, Holger Stephan, Christoph Zwiener
* @version 1.0
*******************************************************************************/

public class Strategie
{
   CommunicationChannel comch;
   WorldModel wmodel;
   TacticalMoves moves;
   boolean nearBall;
   String status = "";
   boolean atBegin = true;
   boolean turned = false;
   boolean turned2 = true;

   public Strategie(CommunicationChannel communicationChannel, WorldModel wmodel)
   {
      this.comch = communicationChannel;
      this.wmodel = wmodel;
      this.moves = new TacticalMoves(comch, wmodel);
   }

   public void start()
   {
      //links = true, rechts = false
      boolean side;
      if (wmodel.getSide()==1)
         side = true;
      else
         side = false;
      nearBall = moves.nearBall(); // nur fr die gui
      switch (wmodel.getPlayMode())
      {
      //beforeKickOff
      case 0:  if (atBegin)
               {
                  moves.setPosition();
                  atBegin = false;
               }
               else if ((wmodel.getSide() == 2) && (turned == true) && (turned2 == true))
               {
                  moves.turn(180); //Drehen zum Mittelpunkt
                  turned2 = false;
               }
               turned = true;
               break;

      //kickOffLeft
      case 1:  if(wmodel.getNumber() == 8 && wmodel.getSide() == 1)
               {
                  if(moves.seeBall())
                  {
                     if (wmodel.getBallDistance() <1)
                        moves.kickBallToPoint(-15, 0);
                     else
                        moves.goGetBall();
                  }
                  else moves.turn(40);
               }
               else
               {
                  moves.turn(moves.calculateTurnAngle(0,0));
               }
               break;

      //kickOffRight
      case 2:  if(wmodel.getNumber() == 8 && wmodel.getSide() == 2)
               {
                  if(moves.seeBall())
                  {
                     if (wmodel.getBallDistance() <1)
                        moves.kickBallToPoint(-15, 0);
                     else
                        moves.goGetBall();
                  }
                  else moves.turn(40);
               }
               else
               {
                  moves.turn(moves.calculateTurnAngle(0,0));
               }
               break;

      //playOn
      case 3:
               if(moves.seeBall())
               {
                  if(wmodel.getNumber() == 1)
                  {
// Goalie
                     //Ball and oponent in penaltyarea and own player outside
                     if(moves.ballInPenaltyArea() && moves.opponentInPenaltyarea() && moves.ownPlayerNotInPenaltyarea())
                     {
                        if(moves.ballCatchable() )
                           moves.catchBall(wmodel.getBallDirection());
                        else
                           moves.goGetBall();
                     }
                     else if(moves.nearBall() && moves.ballInPenaltyArea())
                     {
                        if (moves.ballCatchable())
                           moves.catchBall(wmodel.getBallDirection());
                        else
                           moves.goGetBall();
                     }
                     else
                     {
                           status = "goToGoaliePos";
                           moves.goToGoaliePos();
                     }
// Ende Goalie
                  }
                  else
                  {
                     if(wmodel.getNumber() >= 7)//7
                     {
//Sturm
                        if(moves.nearBall())
                        {
                           if(moves.nearestBall())
                           {
                              moves.sayBallPos();
                              if(wmodel.getBallDistance()<1)
                              {
                                 if(moves.ballInGoalArea())
                                 {
                                    moves.shootToGoal();
                                    status = "shootToGoal";
                                 }
                                 else
                                 {
                                    if(moves.ballInOpponentArea())
                                    {
                                       if(moves.dribblePossible())
                                       {   moves.dribbleBall();
                                          status = "dribbleBall";
                                       }
                                       else
                                          if(moves.passPossible())
                                          {
                                             moves.passBall();
                                             status = "passBall";
                                          }
                                          else
                                          {
                                             moves.changeFieldLine();
                                             status ="changeFieldLine";
                                          }
                                    }
                                    else // Ball nicht in OpponentArea
                                    {
                                       if(moves.passPossible())
                                       {
                                          moves.passBall();
                                          status = "passBall";
                                       }
                                       else
                                          if(moves.dribblePossible())
                                          {
                                             moves.dribbleBall();
                                             status = "dribbleBall";
                                          }
                                          else
                                          {
                                             moves.changeFieldLine();
                                             status ="changeFieldLine";
                                          }
                                    }//Ende if(moves.ballInOpponentArea())

                                 }//Ende if(moves.ballInGoalArea())

                              }
                              else
                              {
                                 moves.goGetBall();
                                 status = "nearest, goGetBall";
                              }//Ende if(wmodel.getBallDistance()<1)

                           }
                           else
                           {
                              if(moves.ballInOpponentArea())
                              {
                                 moves.goToAttackPos();
                                 status = "goToAttackPos";
                              }
                              else
                              {
                                 moves.goGetBall();
                                  status = "near, goGetBall";

                              } //Ende if(moves.ballInOpponentArea())

                           }//Ende if(moves.nearestBall())

                        }
                        else
                        {
                           if(moves.ballInForwardArea())
                           {
                              moves.goToAttackPos();
                              status = "AttackPos";
                           }
                           else
                              if(moves.ballInForwardMiddleArea())
                              {
                                 moves.goToNormalPos();
                                 status = "NormalPos";
                              }
                              else
                              {
                                 moves.goToDefensePos();
                                 status =" DefensePos()";
                              }

                        } //Ende if(moves.nearBall())

//Ende Sturm
                     }
                     else
                     {
//Abwehr
                       if(moves.nearBall())
                        {
                           if(moves.nearestBall())
                           {
                              moves.sayBallPos();
                           }
                           if(wmodel.getBallDistance()<1)
                           {
                                 if(wmodel.getRealBallPosX() <= 0) // Ball eigene Hlfte
                                 {
                                    if(moves.passPossible())
                                    {
                                       moves.passBall();
                                       status = "near passBall";
                                    }
                                    else
                                       {
                                          moves.shootToGoal();
                                          status ="shootGoal";
                                       }
                                 }
                                 else // Ball in gegnerischer Hlfte
                                 {
                                    if(moves.dribblePossible())
                                    {
                                       moves.dribbleBall();
                                       status = "dribbelBall";
                                    }
                                    else
                                       if(moves.passPossible())
                                       {
                                          moves.passBall();
                                          status = "passBall";
                                       }
                                       else
                                       {
                                          moves.shootToGoal();
                                          status = "shootToGoal";
                                       }
                                 }

                           }
                           else
                           {
                              moves.goGetBall();
                              status = "near, getBall";
                           } //Ende if(wmodel.getBallDistance()<1)

                        }
                        else // Spieler ist nicht nahe am Ball
                        {
                           if(moves.ballInOpponentArea())
                           {
                              moves.goToAttackPos();
                              status = "attackPos";
                           }
                           else if(moves.ballInMiddleArea())
                           {
                              moves.goToNormalPos();
                              status = "normalPos";
                           }
                           else
                           {
                              moves.goToDefensePos();
                              status = "defensePos";
                           }
                        }//Ende if(moves.nearBall())

//Ende Abwehr
                     }
                  }
               }
               else //Er sieht den Ball nicht
               {
                 if(moves.nearToNormalPos())
                     moves.turn(40); //Umschauen
                  else
                     moves.goToNormalPos();
               }
               wmodel.setStrategyStatus(status);
               wmodel.setNearBall(nearBall);
               break;

       //timeOver
       case 4: moves.setPosition();
               break;

       //kickInLeft
       case 5: if ( moves.nearestBall() && wmodel.getNumber() != 1 )
               {
                  if (wmodel.getBallDistance() <1)
                     moves.shootToGoal();
                  else
                     moves.goGetBall();
               }
               else moves.goToNormalPos();
               break;

       //kickInRight
       case 6: if(moves.nearestBall() && wmodel.getNumber() != 1)
               {
                  if (wmodel.getBallDistance() <1)
                     moves.shootToGoal();
                  else
                     moves.goGetBall();
               }
               else
                  moves.goToNormalPos();
               break;

       //freeKickLeft
       case 7: if(wmodel.getNumber() == 1)
               {
                  if(wmodel.getRealOwnPlayerPosY() > 18 || wmodel.getRealOwnPlayerPosY() < -18)
                        moves.kick(100, -wmodel.getOwnPlayerRunDirection());
                  moves.moveGoalie();
               }
               else if(moves.nearestBall())
               {
                  if (wmodel.getBallDistance() <1)
                     moves.shootToGoal();
                  else
                     moves.goGetBall();
               }
               else
                  moves.goToNormalPos();
               break;

       //freeKickRight
       case 8: if(wmodel.getNumber() == 1)
               {
                  if(wmodel.getRealOwnPlayerPosY() > 18 || wmodel.getRealOwnPlayerPosY() < -18)
                     moves.kick(100, -wmodel.getOwnPlayerRunDirection());
                  moves.moveGoalie();
               }
               else if(moves.nearestBall())
               {
                  if (wmodel.getBallDistance() <1)
                     moves.shootToGoal();
                  else
                     moves.goGetBall();
               }
               else moves.goToNormalPos();
               break;

       //goalKickLeft
       case 9: if(wmodel.getNumber() == 1 && wmodel.getSide() == 1)
               {
                  if(wmodel.getBallDistance() < 1)
                     moves.kick(100,-wmodel.getOwnPlayerRunDirection());
                  else
                     if (moves.seeBall())
                        moves.goGetBall();
                     else
                        moves.turn(20);
               }
               else
                  moves.goToNormalPos();
               break;

       //goalKickRight
       case 10: if((wmodel.getNumber() == 1) && (wmodel.getSide() == 2))
               {
                  if(wmodel.getBallDistance() < 1)
                     moves.kick(100,-wmodel.getOwnPlayerRunDirection());
                  else
                     if (moves.seeBall())
                        moves.goGetBall();
                     else
                        moves.turn(20);
               }
               else
                  moves.goToNormalPos();
               break;

       //cornerKickLeft
       case 11: if(moves.nearestBall())
                  {
                    if (wmodel.getBallDistance() <1)
                       moves.kickBallToPoint(wmodel.getRealOwnPlayerPosX()-7,0);
                    else
                       moves.goGetBall();
                  }
                  else moves.goToNormalPos();
                  break;

      //cornerKickRight
      case 12: if(moves.nearestBall())
                  {
                    if (wmodel.getBallDistance() <1)
                       moves.kickBallToPoint(wmodel.getRealOwnPlayerPosX()-7,0);
                    else
                       moves.goGetBall();
                  }
                  else moves.goToNormalPos();
                  break;

      //goalLeft
      case 13:  moves.setPosition();
                wmodel.setPlayMode(2);
                break;

      //goalRight
      case 14:  moves.setPosition();
                wmodel.setPlayMode(1);
                break;

      //halfTime
      case 15:  if(wmodel.getSide() == 1)
                { wmodel.setSide(2); }
                if(wmodel.getSide() == 2)
                { wmodel.setSide(1); }
                moves.setPosition();
                wmodel.setPlayMode(1);
                atBegin = true;
                break;

      //default
      case -1000: break;
      }
   }
}