/**
 * <p>Die Klasse initiiert die Objekte des Weltmodells des eigenen Spielers
 * und stellt Zugriffsmethoden auf diese Objekte fuer die GUI und die Strategie
 * zur Verfuegung.</p>
 * @author Alexander Pacnik, Johannes Wechsler
 * @version 2.0
 */

import java.util.*;

public class WorldModel
{
   /** Array vom Typ LineInfo zum Speichern der 4 Linien. */
   private LineInfo[] lineArray;
   /** Objekt vom Typ BallInfo zum Speichern des Balls. */
   private BallInfo ballInfo;
   /** Array vom Typ FlagInfo zum Speichern der 55 Flaggen. */
   private FlagInfo [] flagArray;
   /** Objekt vom Typ OwnPlayerInfo zum Speichern des eigenen Spielers. */
   private OwnPlayerInfo ownPlayerInfo;
   /** Objekt vom Typ GameInfo zum Speichern allgemeiner Spielinformationen. */
   private GameInfo gameInfo;
   /** Vector zum Speichern der Mit- und Gegenspieler. */
   public Vector playerList;

  /**
  * Legt eine <code>WorldModel</code> Instanz an.
  *
  * Anlegen eines Objekts vom Typ GameInfo <br>
  * Anlegen eines Vectors zum Speichern der Mit- und Gegenspieler <br>
  * Anlegen eines Objekts vom Typ Ball <br>
  * Anlegen eines Objekts vom Typ OwnPlayerInfo <br>
  * Anlegen eines Arrays vom Typ LineInfo <br>
  * Anlegen eines Arrays vom Typ FlagInfo <br>
  * Aufruf der Methoden flagTable() und lineTable(), in denen die einzelnen
  * Flaggen und Linien initialisiert werden.
  */
   public WorldModel()
   {
      gameInfo      = new GameInfo();
      playerList    = new Vector(20);
      ballInfo      = new BallInfo();
      ownPlayerInfo = new OwnPlayerInfo();
      flagArray     = new FlagInfo[56];
      lineArray     = new LineInfo[5];
      flagTable();
      lineTable();
   }


   /**
   * Legt die vier Linie an und speichert diese in dem Array lineArray.
   */
   private void lineTable()
   {
      lineArray[1] = new LineInfo(1);
      lineArray[2] = new LineInfo(2);
      lineArray[3] = new LineInfo(3);
      lineArray[4] = new LineInfo(4);
   }

   /**
   * Legt die 55 Flaggen an und speichert diese in dem Array flagArray.
   */
   private void flagTable()
   {
      flagArray[1]   = new FlagInfo (1,   -50, -39, 0);
      flagArray[2]   = new FlagInfo (2,   -40, -39, 0);
      flagArray[3]   = new FlagInfo (3,   -30, -39, 0);
      flagArray[4]   = new FlagInfo (4,   -20, -39, 0);
      flagArray[5]   = new FlagInfo (5,   -10, -39, 0);
      flagArray[6]   = new FlagInfo (6,     0, -39, 0);
      flagArray[7]   = new FlagInfo (7,    10, -39, 0);
      flagArray[8]   = new FlagInfo (8,    20, -39, 0);
      flagArray[9]   = new FlagInfo (9,    30, -39, 0);
      flagArray[10]  = new FlagInfo (10,   40, -39, 0);
      flagArray[11]  = new FlagInfo (11,   50, -39, 0);

      flagArray[12]  = new FlagInfo (12, 57.5, -30, 0);
      flagArray[13]  = new FlagInfo (13, 57.5, -20, 0);
      flagArray[14]  = new FlagInfo (14, 57.5, -10, 0);
      flagArray[15]  = new FlagInfo (15, 57.5, 0, 0);
      flagArray[16]  = new FlagInfo (16, 57.5, 10, 0);
      flagArray[17]  = new FlagInfo (17, 57.5, 20, 0);
      flagArray[18]  = new FlagInfo (18, 57.5, 30, 0);

      flagArray[19]  = new FlagInfo (19,  50, 39, 0);
      flagArray[20]  = new FlagInfo (20,  40, 39, 0);
      flagArray[21]  = new FlagInfo (21,  30, 39, 0);
      flagArray[22]  = new FlagInfo (22,  20, 39, 0);
      flagArray[23]  = new FlagInfo (23,  10, 39, 0);
      flagArray[24]  = new FlagInfo (24,   0, 39, 0);
      flagArray[25]  = new FlagInfo (25, -10, 39, 0);
      flagArray[26]  = new FlagInfo (26, -20, 39, 0);
      flagArray[27]  = new FlagInfo (27, -30, 39, 0);
      flagArray[28]  = new FlagInfo (28, -40, 39, 0);
      flagArray[29]  = new FlagInfo (29, -50, 39, 0);

      flagArray[30]  = new FlagInfo (30, -57.5,  30, 0);
      flagArray[31]  = new FlagInfo (31, -57.5,  20, 0);
      flagArray[32]  = new FlagInfo (32, -57.5,  10, 0);
      flagArray[33]  = new FlagInfo (33, -57.5,   0, 0);
      flagArray[34]  = new FlagInfo (34, -57.5, -10, 0);
      flagArray[35]  = new FlagInfo (35, -57.5, -20, 0);
      flagArray[36]  = new FlagInfo (36, -57.5, -30, 0);

      flagArray[37]  = new FlagInfo (37, -52.5, -34, 0);
      flagArray[38]  = new FlagInfo (38, 0,     -34, 0);
      flagArray[39]  = new FlagInfo (39, 52.5,  -34, 0);

      flagArray[40]  = new FlagInfo (40, 52.5, -7.01, 0);
      flagArray[41]  = new FlagInfo (41, 52.5,     0, 0);
      flagArray[42]  = new FlagInfo (42, 52.5,  7.01, 0);

      flagArray[43]  = new FlagInfo (43,  52.5, 34, 0);
      flagArray[44]  = new FlagInfo (44,     0, 34, 0);
      flagArray[45]  = new FlagInfo (45, -52.5, 34, 0);

      flagArray[46]  = new FlagInfo (46, -52.5,  7.01, 0);
      flagArray[47]  = new FlagInfo (47, -52.5,     0, 0);
      flagArray[48]  = new FlagInfo (48, -52.5, -7.01, 0);

      flagArray[49]  = new FlagInfo (49, 36, -20.175, 0);
      flagArray[50]  = new FlagInfo (50, 36,       0, 0);
      flagArray[51]  = new FlagInfo (51, 36,  20.175, 0);

      flagArray[52]  = new FlagInfo (52, -36,  20.175, 0);
      flagArray[53]  = new FlagInfo (53, -36,       0, 0);
      flagArray[54]  = new FlagInfo (54, -36, -20.175, 0);

      flagArray[55]  = new FlagInfo (55, 0, 0, 0);
   }


//* GUI***********************************************************************//

   /** Setzen, wenn die GUI die Flaggen zeichnet */
   public void setGuiPaintsFlags(boolean guiPaintsFlags)
   { gameInfo.setGuiPaintsFlags(guiPaintsFlags); }

   /** Bestimmen, ob die GUI die Flaggen zeichnet */
   public boolean getGuiPaintsFlags()
   { return gameInfo.getGuiPaintsFlags(); }

//* Strategie*****************************************************************//

   /** Setzen des Status der Strategie */
   public void setStrategyStatus(String status)
   { gameInfo.setStrategyStatus(status); }

   /** Rueckgeben des Status der Strategie */
   public String getStrategyStatus()
   { return gameInfo.getStrategyStatus(); }

   /** Setzen, ob der Spieler nahe beim Ball ist */
   public void setNearBall(boolean nearBall)
   { gameInfo.setNearBall(nearBall); }

   /** Bestimmen, ob der Spieler nahe beim Ball ist */
   public boolean getNearBall()
   { return gameInfo.getNearBall(); }

//* GameInfo******************************************************************//

   /** Setzen der Anzahl unserer Tore */
   public void setOurScore(int ourScore)
   { gameInfo.setOurScore(ourScore); }

   /** Rueckage der Anzahl unserer Tore */
   public int getOurScore()
   { return gameInfo.getOurScore(); }

   /** Setzen der Anzahl der Tore des Gegners*/
   public void setTheirScore(int theirScore)
   { gameInfo.setTheirScore(theirScore); }

   /** Rueckgabe der Anzahl der Tore des Gegners*/
   public int getTheirScore()
   { return gameInfo.getTheirScore(); }

   /** Setzen der aktuellen Zeit*/
   public void setCurrentTime(int currentTime)
   { gameInfo.setCurrentTime(currentTime); }

   /** Bestimmen der aktuellen Zeit*/
   public int getCurrentTime()
   { return gameInfo.getCurrentTime(); }

   /** Setzen des Spielmodus*/
   public void setPlayMode (int playMode)
   { gameInfo.setPlayMode(playMode); }

   /** Bestimmen des Spielmodus*/
   public int getPlayMode()
   { return gameInfo.getPlayMode(); }

   /** Setzen der Seite*/
   public void setSide(int side)
   { gameInfo.setSide(side); }

   /** Setzen der aktuellen Zeit*/
   public int getSide()
   { return gameInfo.getSide(); }

   /** Setzen des Mannschaftsnamens*/
   public void setTeamName(String teamName)
   { gameInfo.setTeamName(teamName); }

   /** Rueckgeben des Mannschaftsnamens*/
   public String getTeamName()
   { return gameInfo.getTeamName(); }

//* OwnPlayer*****************************************************************//

   /** Setzen der Zeit, zu der der Torwart zum letzten Mal den Ball gefangen hat*/
   public void setCatchBan(int time)
   { ownPlayerInfo.setCatchBanTime(time); }

   /** Bestimmen, ob der Torwart in den letzten 5 Zyklen den Ball gefangen hat*/
   public boolean getCatchBan()
   {
      if ((ownPlayerInfo.getCatchBanTime() +5) > getCurrentTime())
      { return true; }
      else
      { return false; }
   }

   /** Setzen der Spielernummer*/
   public void setID(int ID)
   { ownPlayerInfo.setID(ID); }

   /** Rueckgeben der Spielernummer*/
   public int getID()
   { return ownPlayerInfo.getID(); }

   /** Setzen der Spielernummer*/
   public void setNumber(int ID)
   { setID(ID); }

   /** Rueckgeben der Spielernummer*/
   public int getNumber()
   { return getID(); }

   /** Setzen der eigenen X Position*/
   public void setOwnPlayerPosX(double posX)
   { ownPlayerInfo.setPosX(posX); }

   /** Rueckgeben der eigenen X Position*/
   public double getOwnPlayerPosX()
   { return ownPlayerInfo.getPosX(); }

   /** Setzen der eigenen Y Position*/
   public void setOwnPlayerPosY(double posY)
   { ownPlayerInfo.setPosY(posY); }

   /** Rueckgeben der eigenen Y Position*/
   public double getOwnPlayerPosY()
   { return ownPlayerInfo.getPosY(); }

   /** Setzen der eigenen real-X Position*/
   public void setRealOwnPlayerPosX(double realPosX)
   { ownPlayerInfo.setRealPosX(realPosX); }

   /** Rueckgeben der eigenen real-X Position*/
   public double getRealOwnPlayerPosX()
   { return ownPlayerInfo.getRealPosX(); }

   /** Setzen der eigenen real-Y Position*/
   public void setRealOwnPlayerPosY(double realPosY)
   { ownPlayerInfo.setRealPosY(realPosY); }

   /** Rueckgeben der eigenen real-Y Position*/
   public double getRealOwnPlayerPosY()
   { return ownPlayerInfo.getRealPosY(); }

   /** Setzen der eigenen Blickrichtung fuer interne Berechnungen*/
   public void setOwnPlayerViewDirection(double viewDirection)
   { ownPlayerInfo.setOwnPlayerViewDirection(viewDirection); }

   /** Rueckgeben der eigenen Blickrichtung fuer interne Berechnungen*/
   public double getOwnPlayerViewDirection()
   { return ownPlayerInfo.getOwnPlayerViewDirection(); }

   /** Setzen der eigenen Blickrichtung fuer die Strategie*/
   public void setRealViewDirection(double realViewDirection)
   { ownPlayerInfo.setRealViewDirection(realViewDirection); }

   /** Rueckgeben der eigenen Blickrichtung fuer die Strategie*/
   public double getRealViewDirection()
   { return ownPlayerInfo.getRealViewDirection(); }

   /** Setzen der eigenen Laufrichtung*/
   public void setOwnPlayerRunDirection(double runDirection)
   { ownPlayerInfo.setRunDirection(runDirection); }

   /** Rueckgeben der eigenen Laufrichtung*/
   public double getOwnPlayerRunDirection()
   { return ownPlayerInfo.getRunDirection(); }

   /** Setzen, ob der Spieler sich ausserhalb des Spielfeldes befindet*/
   public void setOwnPlayerOutside(boolean playerOutside)
   { ownPlayerInfo.setOutside(playerOutside); }

   /** Bestimmen, ob der Spieler sich ausserhalb des Spielfeldes befindet*/
   public boolean isOwnPlayerOutside()
   { return ownPlayerInfo.isOutside(); }

   /** Setzen, ob der Spieler sich nahe am Spielfeldrand befindet*/
   public void setOwnPlayerNearOutside(boolean playerNearOutside)
   { ownPlayerInfo.setNearOutside(playerNearOutside); }

   /** Bestimmen, ob der Spieler sich nahe am Spielfeldrand befindet*/
   public boolean isOwnPlayerNearOutside()
   { return ownPlayerInfo.isNearOutside(); }

   /** Setzen der Qualitaet des Sichtfeldes*/
   public void setViewModeQuality(int viewModeQuality)
   { ownPlayerInfo.setViewModeQuality(viewModeQuality); }

   /** Rueckgeben der Qualitaet des Sichtfeldes*/
    public int getViewModeQuality()
   { return ownPlayerInfo.getViewModeQuality(); }

   /** Setzen der Weite des Sichtfeldes*/
   public void setViewModeRange(int viewModeRange)
   { ownPlayerInfo.setViewModeRange(viewModeRange); }

   /** Rueckgeben der Weite des Sichtfeldes*/
   public int getViewModeRange()
   { return ownPlayerInfo.getViewModeRange(); }

   /** Setzen der verbleibenden Kraft*/
   public void setStamina(double stamina)
   { ownPlayerInfo.setStamina(stamina); }

   /** Rueckgeben der verbleibenden Kraft*/
   public double getStamina()
   { return ownPlayerInfo.getStamina(); }

   /** Setzen der aktuellen Anstrengung*/
   public void setEffort(double effort)
   { ownPlayerInfo.setEffort(effort); }

   /** Rueckgeben der aktuellen Anstrengung*/
   public double getEffort()
   { return ownPlayerInfo.getEffort(); }

   /** Setzen der Staerke der eigenen Geschwindigkeit*/
   public void setAmountOfSpeed(double amountOfSpeed)
   { ownPlayerInfo.setAmountOfSpeed(amountOfSpeed); }

   /** Rueckgeben der Staerke der eigenen Geschwindigkeit*/
   public double getAmountOfSpeed()
   { return ownPlayerInfo.getAmountOfSpeed(); }

   /** Setzen der Richtung der eigenen Geschwindigkeit*/
   public void setDirectionOfSpeed(double directionOfSpeed)
   { ownPlayerInfo.setDirectionOfSpeed(directionOfSpeed); }

   /** Rueckgeben der Richtung der eigenen Geschwindigkeit*/
   public double getDirectionOfSpeed()
   { return ownPlayerInfo.getDirectionOfSpeed(); }

   /** Setzen des Winkels der Kopfdrehung*/
   public void setHeadAngle(double headAngle)
   { ownPlayerInfo.setHeadAngle(headAngle); }

   /** Rueckgeben des Winkels der Kopfdrehung*/
   public double getHeadAngle()
   { return ownPlayerInfo.getHeadAngle(); }

   /** Setzen der Anzahl der ausgefuehrten Kick Befehle*/
   public void setKickCount(int kickCount)
   { ownPlayerInfo.setKickCount(kickCount); }

   /** Rueckgeben der Anzahl der ausgefuehrten Kick Befehle*/
   public int getKickCount()
   { return ownPlayerInfo.getKickCount(); }

   /** Setzen der Anzahl der ausgefuehrten Dash Befehle*/
   public void setDashCount(int dashCount)
   { ownPlayerInfo.setDashCount(dashCount); }

   /** Rueckgeben der Anzahl der ausgefuehrten Kick Befehle*/
   public int getDashCount()
   { return ownPlayerInfo.getDashCount(); }

   /** Setzen der Anzahl der ausgefuehrten Turn Befehle*/
   public void setTurnCount(int turnCount)
   { ownPlayerInfo.setTurnCount(turnCount); }

   /** Rueckgeben der Anzahl der ausgefuehrten Turn Befehle*/
   public int getTurnCount()
   { return ownPlayerInfo.getTurnCount(); }

   /** Setzen der Anzahl der ausgefuehrten Say Befehle*/
   public void setSayCount(int sayCount)
   { ownPlayerInfo.setSayCount(sayCount); }

   /** Rueckgeben der Anzahl der ausgefuehrten Say Befehle*/
   public int getSayCount()
   { return ownPlayerInfo.getSayCount(); }

   /** Setzen der Anzahl der ausgefuehrten TurnNeck Befehle*/
   public void setTurnNeckCount(int turnNeckCount)
   { ownPlayerInfo.setTurnNeckCount(turnNeckCount); }

   /** Rueckgeben der Anzahl der ausgefuehrten TurnNeck Befehle*/
   public int getTurnNeckCount()
   { return ownPlayerInfo.getTurnNeckCount(); }

   /** Setzen der Anzahl der ausgefuehrten Catch Befehle*/
   public void setCatchCount(int catchCount)
   { ownPlayerInfo.setCatchCount(catchCount); }

   /** Rueckgeben der Anzahl der ausgefuehrten Catch Befehle*/
   public int getCatchCount()
   { return ownPlayerInfo.getCatchCount(); }

   /** Setzen der Anzahl der ausgefuehrten Move Befehle*/
   public void setMoveCount(int moveCount)
   { ownPlayerInfo.setMoveCount(moveCount); }

   /** Rueckgeben der Anzahl der ausgefuehrten Move Befehle*/
   public int getMoveCount()
   { return ownPlayerInfo.getMoveCount(); }

   /** Setzen der Anzahl der ausgefuehrten ChangeView Befehle*/
   public void setChangeViewCount(int changeViewCount)
   { ownPlayerInfo.setChangeViewCount(changeViewCount); }

   /** Rueckgeben der Anzahl der ausgefuehrten ChangeView Befehle*/
   public int getChangeViewCount()
   { return ownPlayerInfo.getChangeViewCount(); }

   /** Anpassung der Blickrichtung, wenn der Spieler sich dreht*/
   public void turnDirection(double turnDirection)
   {
      double viewDirection = getRealViewDirection() + turnDirection;

      if (viewDirection > 180)
      { viewDirection -= 360; }
      else if (viewDirection < (-180))
      { viewDirection += 360; }

      setRealViewDirection(viewDirection);
   }

//* Ball**********************************************************************//

   /** Setzen der X Position des Balls in drei Zyklen*/
   public void setBallNextPosX1(double nextPosX1)
   { ballInfo.setNextPosX1(nextPosX1); }

   /** Rueckgeben der X Position des Balls in drei Zyklen*/
   public double getBallNextPosX1()
   { return ballInfo.getNextPosX1(); }

   /** Setzen der Y Position des Balls in drei Zyklen*/
   public void setBallNextPosY1(double nextPosY1)
   { ballInfo.setNextPosY1(nextPosY1); }

   /** Rueckgeben der Y Position des Balls in drei Zyklen*/
   public double getBallNextPosY1()
   { return ballInfo.getNextPosY1(); }

   /** Setzen der X Position des Balls in sechs Zyklen*/
   public void setBallNextPosX2(double nextPosX2)
   { ballInfo.setNextPosX2(nextPosX2); }

   /** Rueckgeben der X Position des Balls in sechs Zyklen*/
   public double getBallNextPosX2()
   { return ballInfo.getNextPosX2(); }

   /** Setzen der Y Position des Balls in sechs Zyklen*/
   public void setBallNextPosY2(double nextPosY2)
   { ballInfo.setNextPosY2(nextPosY2); }

   /** Rueckgeben der Y Position des Balls in sechs Zyklen*/
   public double getBallNextPosY2()
   { return ballInfo.getNextPosY2(); }

   /** Setzen der aktuellen X Position des Balls*/
   public void setBallPosX(double posX)
   { ballInfo.setPosX(posX); }

   /** Rueckgeben der aktuellen X Position des Balls*/
   public double getBallPosX()
   { return ballInfo.getPosX(); }

   /** Setzen der aktuellen Y Position des Balls*/
   public void setBallPosY(double posY)
   { ballInfo.setPosY(posY); }

   /** Rueckgeben der aktuellen Y Position des Balls*/
   public double getBallPosY()
   { return ballInfo.getPosY(); }

   /** Setzen der vorherigen X Position des Balls*/
   public void setBallPreviousPosX(double previousPosX)
   { ballInfo.setPreviousPosX(previousPosX); }

   /** Rueckgeben der vorherigen X Position des Balls*/
   public double getBallPreviousPosX()
   { return ballInfo.getPreviousPosX(); }

   /** Setzen der vorherigen Y Position des Balls*/
   public void setBallPreviousPosY(double previousPosY)
   { ballInfo.setPreviousPosY(previousPosY); }

   /** Rueckgeben der vorherigen X Position des Balls*/
   public double getBallPreviousPosY()
   { return ballInfo.getPreviousPosY(); }

   /** Setzen der real-X Position des Balls in drei Zyklen*/
   public void setRealBallNextPosX1(double realNextPosX1)
   { ballInfo.setRealNextPosX1(realNextPosX1); }

   /** Rueckgeben der real-X Position des Balls in drei Zyklen*/
   public double getRealBallNextPosX1()
   { return ballInfo.getRealNextPosX1(); }

   /** Setzen der real-Y Position des Balls in drei Zyklen*/
   public void setRealBallNextPosY1(double realNextPosY1)
   { ballInfo.setRealNextPosY1(realNextPosY1); }

   /** Rueckgeben der real-Y Position des Balls in drei Zyklen*/
   public double getRealBallNextPosY1()
   { return ballInfo.getRealNextPosY1(); }

   /** Setzen der real-X Position des Balls in sechs Zyklen*/
   public void setRealBallNextPosX2(double realNextPosX2)
   { ballInfo.setRealNextPosX2(realNextPosX2); }

   /** Rueckgeben der real-X Position des Balls in sechs Zyklen*/
   public double getRealBallNextPosX2()
   { return ballInfo.getRealNextPosX2(); }

   /** Setzen der real-Y Position des Balls in sechs Zyklen*/
   public void setRealBallNextPosY2(double realNextPosY2)
   { ballInfo.setRealNextPosY2(realNextPosY2); }

   /** Rueckgeben der real-Y Position des Balls in sechs Zyklen*/
   public double getRealBallNextPosY2()
   { return ballInfo.getRealNextPosY2(); }

   /** Setzen der aktuellen real-X Position des Balls*/
   public void setRealBallPosX(double realPosX)
   { ballInfo.setRealPosX(realPosX); }

   /** Rueckgeben der aktuellen real-X Position des Balls*/
   public double getRealBallPosX()
   { return ballInfo.getRealPosX(); }

   /** Setzen der aktuellen real-Y Position des Balls*/
   public void setRealBallPosY(double realPosY)
   { ballInfo.setRealPosY(realPosY); }

   /** Rueckgeben der aktuellen real-Y Position des Balls*/
   public double getRealBallPosY()
   { return ballInfo.getRealPosY(); }

   /** Setzen der vorherigen real-X Position des Balls*/
   public void setRealBallPreviousPosX(double realPreviousPosX)
   { ballInfo.setRealPreviousPosX(realPreviousPosX); }

   /** Rueckgeben der vorherigen real-X Position des Balls*/
   public double getRealBallPreviousPosX()
   { return ballInfo.getRealPreviousPosX(); }

   /** Setzen der vorherigen real-Y Position des Balls*/
   public void setRealBallPreviousPosY(double realPreviousPosY)
   { ballInfo.setRealPreviousPosY(realPreviousPosY); }

   /** Rueckgeben der vorherigen real-X Position des Balls*/
   public double getRealBallPreviousPosY()
   { return ballInfo.getRealPreviousPosY(); }

   /** Setzen der Entfernung des Balls*/
   public void setBallDistance(double distance)
   { ballInfo.setDistance(distance); }

   /** Rueckgeben der Entfernung des Balls*/
   public double getBallDistance()
   { return ballInfo.getDistance(); }

   /** Setzen der Richtung, in dem wir den Ball sehen*/
   public void setBallDirection(double direction)
   { ballInfo.setDirection(direction); }

   /** Rueckgeben der Richtung, in dem wir den Ball sehen*/
   public double getBallDirection()
   { return ballInfo.getDirection(); }

   /** Setzen der Zeit, zu der zum letzten Mal den Ball gesehen haben*/
   public void setBallTime(int time)
   { ballInfo.setTime(time); }

   /** Rueckgeben der Zeit, zu der zum letzten Mal den Ball gesehen haben*/
   public int getBallTime()
   { return ballInfo.getTime(); }

   /** Setzen der Aenderung der Richtung des Balls*/
   public void setBallDirectionChange(double directionChange)
   { ballInfo.setDirectionChange(directionChange); }

   /** Rueckgeben der Aenderung der Richtung des Balls*/
   public double getBallDirectionChange()
   { return ballInfo.getDirectionChange(); }

   /** Setzen der Aenderung der Entfernung des Balls*/
   public void setBallDistanceChange(double distanceChange)
   { ballInfo.setDistanceChange(distanceChange); }

   /** Rueckgeben der Aenderung der Entfernung des Balls*/
   public double getBallDistanceChange()
   { return ballInfo.getDistanceChange(); }

   /** Setzen des Geschwindigkeitvektors des Balls*/
   public void setBallSpeedVector(double speedVector)
   { ballInfo.setSpeedVector(speedVector); }

   /** Rueckgeben des Geschwindigkeitsvektors des Balls*/
   public double getBallSpeedVector()
   { return ballInfo.getSpeedVector(); }

   /** Bestimmen, ob der Ball in den letzten zehn Zyklen gesehn wurde*/
   public boolean isBallVisible()
   {
      if ((getBallTime() + 10) >= getCurrentTime())
      { return true; }
      else
      { return false; }
   }

//* Flags*********************************************************************//

   /** Setzen der Entfernung der Flagge <ID>*/
   public void setFlagDistance(int ID, double distance)
   { flagArray[ID].setDistance(distance); }

   /** Rueckgeben der Entfernung der Flagge <ID>*/
   public double getFlagDistance(int ID)
   { return flagArray[ID].getDistance(); }

   /** Setzen der Richtung, in der wir die Flagge <ID> sehen*/
   public void setFlagDirection(int ID, double direction)
   { flagArray[ID].setDirection(direction); }

   /** Rueckgeben der Richtung, in der wir die Flagge <ID> sehen*/
   public double getFlagDirection(int ID)
   { return flagArray[ID].getDirection(); }

   /** Setzen der Zeit, zu der wir die Flagge <ID> zum letzten Mal gesehen haben*/
   public void setFlagTime(int ID, int time)
   { flagArray[ID].setTime(time); }

   /** Rueckgeben der Zeit, zu der wir die Flagge <ID> zum letzten Mal gesehen haben*/
   public int getFlagTime(int ID)
   { return flagArray[ID].getTime(); }

   /** Setzen der X Position der Flagge <ID>*/
   public void setFlagPosX(int ID, double posX)
   { flagArray[ID].setPosX(posX); }

   /** Rueckgeben der X Position der Flagge <ID>*/
   public double getFlagPosX(int ID)
   { return flagArray[ID].getPosX(); }

   /** Setzen der Y Position der Flagge <ID>*/
   public void setFlagPosY(int ID, double posY)
   { flagArray[ID].setPosY(posY); }

   /** Rueckgeben der Y Position der Flagge <ID>*/
   public double getFlagPosY(int ID)
   { return flagArray[ID].getPosY(); }

   /** Setzen der wahrgenommenen X Position der Flagge <ID>*/
   public void setFlagEstPosX(int ID, double estPosX)
   { flagArray[ID].setEstPosX(estPosX); }

   /** Rueckgeben der wahrgenommenen X Position der Flagge <ID>*/
   public double getFlagEstPosX(int ID)
   { return flagArray[ID].getEstPosX(); }

   /** Setzen der wahrgenommenen Y Position der Flagge <ID>*/
   public void setFlagEstPosY(int ID, double estPosY)
   { flagArray[ID].setEstPosY(estPosY); }

   /** Rueckgeben der wahrgenommenen Y Position der Flagge <ID>*/
   public double getFlagEstPosY(int ID)
   { return flagArray[ID].getEstPosY(); }

   /** Rueckgeben der Flagge <ID>*/
   public FlagInfo getFlag(int ID)
   { return flagArray[ID]; }

//* Lines*********************************************************************//

   /** Setzen der Entfernung der Linie <ID>*/
   public void setLineDistance(int ID, double distance)
   { lineArray[ID].setDistance(distance); }

   /** Rueckgeben der Entfernung der Linie <ID>*/
   public double getLineDistance(int ID)
   { return lineArray[ID].getDistance(); }

   /** Setzen der Richtung, in der wir die Linie <ID> sehen*/
   public void setLineDirection(int ID, double direction)
   { lineArray[ID].setDirection(direction); }

   /** Rueckgeben der Richtung, in der wir die Linie <ID> sehen*/
   public double getLineDirection(int ID)
   { return lineArray[ID].getDirection(); }

   /** Setzen der Zeit, in der wir die Linie <ID> zum letzten Mal gesehen haben*/
   public void setLineTime(int ID, int time)
   { lineArray[ID].setTime(time); }

   /** Rueckgeben der Zeit, in der wir die Linie <ID> zum letzten Mal gesehen haben*/
   public int getLineTime(int ID)
   { return lineArray[ID].getTime(); }

   /** Rueckgeben der Linie <ID>*/
   public LineInfo getLine(int ID)
   { return lineArray[ID]; }
}