/**
 * <p>This calss is invoked by the player class. It is starting the receive
 * method of the CommunicationChannel and is roughly evaluating the incoming
 * strings.</p>
 * @author Alexander Pacnik, Johannes Wechsler
 * @version 1.0
 */

public class EventHandler
{

   private boolean isVisualEvent   = false;
   private boolean isBodyEvent     = false;
   private boolean isAccusticEvent = false;
   private boolean isInitEvent     = false;
   private boolean isScoreEvent    = false;

   //Constructor
   public EventHandler(CommunicationChannel communicationChannel)
   {
      this.communicationChannel = communicationChannel;
   }

   //Methode event() lauscht, bis eine Nachricht vom Server kommt und ruft fr
   //diese die entsprechende Methode in STokenizer auf
   public void event()
   {
      String msg;
      STokenizer sTokenizer = new STokenizer();

      while ((isVisualEvent==false) && (isBodyEvent==false) && (isAccusticEvent==false  && (isInitEvent == false) && (isScoreEvent == false)))
      {
         msg = communicationChannel.receive(); // receive server message - block until one arrives

         //Visual Events: see
         if (msg.startsWith("(see"))
         {
            sTokenizer.visualTokenizer(msg);
            isVisualEvent=true;
         }

         //Accustic Events: hear
         if (msg.startsWith("(hear"))
         {
            sTokenizer.accusticTokenizer(msg);
            isAccusticEvent=true;
         }

         //BodySense Events: sense_body
         if (msg.startsWith("(sense_body"))
         {
            sTokenizer.bodyTokenizer(msg);
            isBodyEvent=true;
         }


         //Init Events: init
         if (msg.startsWith("(init"))
         {
            sTokenizer.initTokenizer(msg);
            isInitEvent=true;
         }

         //Score Events: score
         if (msg.startsWith("(score"))
         {
            sTokenizer.scoreTokenizer(msg);
            isScoreEvent=true;
         }
      }
   }


   //Folgende Methoden geben an, welcher Event gerade verarbeitet wird
   public boolean getVisualEvent()
   { return isVisualEvent; }

   public boolean getAccusticEvent()
   { return isAccusticEvent; }

   public boolean getBodyEvent()
   { return isBodyEvent; }

   public boolean isInitEvent()
   {  return isInitEvent; }

   public boolean isScoreEvent()
   {  return isScoreEvent; }

}
