/**
 * <p>This class saves the flags in an array. The default values are: ID =
 * 1..55, distance, direction = -1000, posX, posY = absolute positions, time =
 * 0.</p>
 * @author Alexander Pacnik, Johannes Wechsler
 * @version 1.0
 */

class FlagTable
{
      FlagInfo [] flagArray = new FlagInfo[56];

   // Konstruktor
   public FlagTable()
   {
      //bergabeformat: FlagInfo(int ID, double distance, double direction, double posX, double posY, int time)
      flagArray[1] = new FlagInfo (1,   -1000, -1000, -50, -39, 0);
      flagArray[2]  = new FlagInfo (2,   -1000, -1000, -40, -39, 0);
      flagArray[3]  = new FlagInfo (3,   -1000, -1000, -30, -39, 0);
      flagArray[4]  = new FlagInfo (4,   -1000, -1000, -20, -39, 0);
      flagArray[5]  = new FlagInfo (5,   -1000, -1000, -10, -39, 0);
      flagArray[6]  = new FlagInfo (6,   -1000, -1000,   0, -39, 0);
      flagArray[7]  = new FlagInfo (7,   -1000, -1000,  10, -39, 0);
      flagArray[8]  = new FlagInfo (8,   -1000, -1000,  20, -39, 0);
      flagArray[9]  = new FlagInfo (9,   -1000, -1000,  30, -39, 0);
      flagArray[10]  = new FlagInfo (10, -1000, -1000,  40, -39, 0);
      flagArray[11]  = new FlagInfo (11, -1000, -1000,  50, -39, 0);

      flagArray[12]  = new FlagInfo (12, -1000, -1000, 57.5, -30, 0);
      flagArray[13]  = new FlagInfo (13, -1000, -1000, 57.5, -20, 0);
      flagArray[14]  = new FlagInfo (14, -1000, -1000, 57.5, -10, 0);
      flagArray[15]  = new FlagInfo (15, -1000, -1000, 57.5, 0, 0);
      flagArray[16]  = new FlagInfo (16, -1000, -1000, 57.5, 10, 0);
      flagArray[17]  = new FlagInfo (17, -1000, -1000, 57.5, 20, 0);
      flagArray[18]  = new FlagInfo (18, -1000, -1000, 57.5, 30, 0);

      flagArray[19]  = new FlagInfo (19, -1000, -1000,  50, 39, 0);
      flagArray[20]  = new FlagInfo (20, -1000, -1000,  40, 39, 0);
      flagArray[21]  = new FlagInfo (21, -1000, -1000,  30, 39, 0);
      flagArray[22]  = new FlagInfo (22, -1000, -1000,  20, 39, 0);
      flagArray[23]  = new FlagInfo (23, -1000, -1000,  10, 39, 0);
      flagArray[24]  = new FlagInfo (24, -1000, -1000,   0, 39, 0);
      flagArray[25]  = new FlagInfo (25, -1000, -1000, -10, 39, 0);
      flagArray[26]  = new FlagInfo (26, -1000, -1000, -20, 39, 0);
      flagArray[27]  = new FlagInfo (27, -1000, -1000, -30, 39, 0);
      flagArray[28]  = new FlagInfo (28, -1000, -1000, -40, 39, 0);
      flagArray[29]  = new FlagInfo (29, -1000, -1000, -50, 39, 0);

      flagArray[30]  = new FlagInfo (30, -1000, -1000, -57.5, 30, 0);
      flagArray[31]  = new FlagInfo (31, -1000, -1000, -57.5, 20, 0);
      flagArray[32]  = new FlagInfo (32, -1000, -1000, -57.5, 10, 0);
      flagArray[33]  = new FlagInfo (33, -1000, -1000, -57.5, 0, 0);
      flagArray[34]  = new FlagInfo (34, -1000, -1000, -57.5, -10, 0);
      flagArray[35]  = new FlagInfo (35, -1000, -1000, -57.5, -20, 0);
      flagArray[36]  = new FlagInfo (36, -1000, -1000, -57.5, -30, 0);

      flagArray[37]  = new FlagInfo (37, -1000, -1000, -34, -52.5, 0);
      flagArray[38]  = new FlagInfo (38, -1000, -1000, -34, 0, 0);
      flagArray[39]  = new FlagInfo (39, -1000, -1000, -34, 52.5, 0);

      flagArray[40]  = new FlagInfo (40, -1000, -1000, 52.5, -7.01, 0);
      flagArray[41]  = new FlagInfo (41, -1000, -1000, 52.5, 0, 0);
      flagArray[42]  = new FlagInfo (42, -1000, -1000, 52.5, 7.01, 0);

      flagArray[43]  = new FlagInfo (43, -1000, -1000, 52.5, 34, 0);
      flagArray[44]  = new FlagInfo (44, -1000, -1000, 0, 34, 0);
      flagArray[45]  = new FlagInfo (45, -1000, -1000, -52.5, 34, 0);

      flagArray[46]  = new FlagInfo (46, -1000, -1000, -52.5, 7.01, 0);
      flagArray[47]  = new FlagInfo (47, -1000, -1000, -52.5, 0, 0);
      flagArray[48]  = new FlagInfo (48, -1000, -1000, -52.5, -7.01, 0);

      flagArray[49]  = new FlagInfo (49, -1000, -1000, 36, -20.175, 0);
      flagArray[50]  = new FlagInfo (50, -1000, -1000, 36, 0, 0);
      flagArray[51]  = new FlagInfo (51, -1000, -1000, 36, 20.175, 0);

      flagArray[52]  = new FlagInfo (52, -1000, -1000, -36, 20.175, 0);
      flagArray[53]  = new FlagInfo (53, -1000, -1000, -36, 0, 0);
      flagArray[54]  = new FlagInfo (54, -1000, -1000, -36, -20.175, 0);

      flagArray[55]  = new FlagInfo (55, -1000, -1000, 0, 0, 0);
   }
}
