/*******************************************************************************
*   public class OwnPlayerInfo extends PlayerInfo                              *
*                                                                              *
*   The class defines the characteristics of the own player:                   *
*   bodyDirection, faceDirection, neckDirection, side, goalie, stamina         *
*   In addition, the own player has the following properties:                  *
*   distance, direction, posX, posY, dirctionChange, distanceChange,           *
*   speedVector, uniformNumber, ourTeam                                        *
*                                                                              *
*   @author Alexander Pacnik, Johannes Wechsler                                *
*   @revised by                                                                *
*   @version 1.0                                                               *
*******************************************************************************/


public class OwnPlayerInfo extends PlayerInfo
{
   protected int    number;
   protected int    viewModeQuality;        //high=1 oder low=2
   protected int    viewModeRange;          //narrow=1, normal=2 oder wide=3
   protected int    stamina;
   protected int    effort;
   protected double amountOfSpeed;
   protected double directionOfSpeed;
   protected double headAngle;
   protected int    kickCount;
   protected int    dashCount;
   protected int    turnCount;
   protected int    sayCount;
   protected int    turnNeckCount;
   protected int    catchCount;
   protected int    moveCount;
   protected int    changeViewCount;

   protected double viewDirection;

   protected boolean goalie;                 //goalie = true; not goalie = false

  /* public OwnPlayerInfo()
   {
      number = -1000;
      viewModeQuality = -1000;
      viewModeRange = -1000;
      stamina = -1000;
      effort = -1000;
      amountOfSpeed = -1000;
      directionOfSpeed = -1000;
      headAngle = -1000;
      kickCount = -1000;
      dashCount = -1000;
      turnCount = -1000;
      sayCount = -1000;
      turnNeckCount = -1000;
      catchCount = -1000;
      moveCount = -1000;
      changeViewCount = -1000;
      side = -1000;
      playMode = -1000;
      currentTime = -1000;
   }*/

   public OwnPlayerInfo(int number, int viewModeQuality, int viewModeRange, int stamina, int effort, double amountOfSpeed, double directionOfSpeed, double headAngle, int kickCount, int dashCount, int turnCount, int sayCount, int turnNeckCount, int catchCount, int moveCount, int changeViewCount)
   {
      this.number = number;
      this.viewModeQuality = viewModeQuality;
      this.viewModeRange = viewModeRange;
      this.stamina = stamina;
      this.effort = effort;
      this.amountOfSpeed = amountOfSpeed;
      this.directionOfSpeed = directionOfSpeed;
      this.headAngle = headAngle;
      this.kickCount = kickCount;
      this.dashCount = dashCount;
      this.turnCount = turnCount;
      this.sayCount = sayCount;
      this.turnNeckCount = turnNeckCount;
      this.catchCount = catchCount;
      this.moveCount = moveCount;
      this.changeViewCount = changeViewCount;
   }

   //Positionsberechnung
   public void setOwnPlayerPosX(double posX)
   { this.posX = posX; }

   public void setOwnPlayerPosY(double posY)
   { this.posY = posY; }

   public double getOwnPlayerPosX()
   { return this.posX; }

   public double getOwnPlayerPosY()
   { return this.posY; }

   public double getOwnPlayerViewDirection()
   { return this.viewDirection; }

   public void setOwnPlayerViewDirection(double viewDirection)
   { this.viewDirection = viewDirection; }

   //Ende Positionsberechnung
   public void setNumber(int number)
   { this.number = number; }

   public int getNumber()
   { return this.number; }

   public void setViewModeQuality(int viewModeQuality)
   {  this.viewModeQuality = viewModeQuality; }

   public int getViewModeQuality()
   { return this.viewModeQuality; }

   public void setViewModeRange(int viewModeRange)
   {  this.viewModeRange = viewModeRange; }

   public int getViewModeRange()
   { return this.viewModeRange; }

   public void setStamina(int stamina)
   {  this.stamina = stamina; }

   public int getStamina()
   { return this.stamina; }

   public void setEffort(int effort)
   {  this.effort = effort; }

   public int getEffort()
   { return this.effort; }

   public void setAmountOfSpeed(double amountOfSpeed)
   {  this.amountOfSpeed = amountOfSpeed; }

   public double getAmountOfSpeed()
   { return this.amountOfSpeed; }

   public void setDirectionOfSpeed(double directionOfSpeed)
   {  this.directionOfSpeed = directionOfSpeed; }

   public double getDirectionOfSpeed()
   { return this.directionOfSpeed; }

   public void setHeadAngle(double headAngle)
   {  this.headAngle = headAngle; }

   public double getHeadAngle()
   { return this.headAngle; }

   public void setKickCount(int kickCountNew)
   { this.kickCount = kickCount; }

   public int getKickCount()
   { return this.kickCount; }

   public void setDashCount(int dashCount)
   { this.dashCount = dashCount; }

   public int getDashCount()
   { return this.dashCount; }

   public void setTurnCount(int turnCount)
   { this.turnCount = turnCount; }

   public int getTurnCount()
   { return this.turnCount; }

   public void setSayCount(int sayCount)
   { this.sayCount = sayCount; }

   public int getSayCount()
   { return this.sayCount; }

   public void setTurnNeckCount(int turnNeckCount)
   { this.turnNeckCount = turnNeckCount; }

   public int getTurnNeckCount()
   { return this.turnNeckCount; }

   public void setCatchCount(int catchCount)
   { this.catchCount = catchCount; }

   public int getCatchCount()
   { return this.catchCount; }

   public void setMoveCount(int moveCount)
   { this.moveCount = moveCount; }

   public int getMoveCount()
   { return this.moveCount; }

   public void setChangeViewCount(int changeViewCount)
   { this.changeViewCount = changeViewCount; }

   public int getChangeViewCount()
   { return this.changeViewCount; }

   public void setGoalie(boolean goalie)
   { this.goalie = goalie; }

   public boolean isGoalie()
   { return this.goalie; }
}